package com.yihu.hos.agent.service;

import com.yihu.hos.agent.configuration.AgentConfiguration;
import com.yihu.hos.agent.constant.FlowConstant;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.zbus.broker.ZbusBroker;
import org.zbus.mq.Consumer;
import org.zbus.net.http.Message;

import java.io.IOException;

/**
 * @author Airhead
 * @since 2017/1/19.
 */
@Service
public class MycatService {
    private static final Logger logger = LogManager.getLogger(ShellService.class);

    private ZbusBroker zbusBroker;
    private Consumer consumer;
    private AgentConfiguration configuration;

    @Autowired
    public void setZbusBroker(ZbusBroker zbusBroker) {
        this.zbusBroker = zbusBroker;
    }

    @Autowired
    public void setConfiguration(AgentConfiguration configuration) {
        this.configuration = configuration;
    }

    @Override
    protected void finalize() throws Throwable {
        consumer.close();
        super.finalize();
    }

    public void server(){
        if (zbusBroker == null) {
            logger.error("zbusBroker is null");
            return;
        }

        consumer = new Consumer(zbusBroker, FlowConstant.PREFIX + "@" + configuration.getTenant());
        try {
            consumer.start(this::handle);
        } catch (IOException e) {
            e.printStackTrace();
            logger.error(e.getMessage());
        }
    }

    public void handle(Message message, Consumer consumer) {
    }
}
